/*	Renegade Scripts.dll
	Example implementation of shaders.dll plugin interface
	Copyright 2007 Mark Sararu

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module 
	that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/

class ExampleShaderPluginClass: public ShaderPluginClass
{
public:
	ExampleShaderPluginClass();
	HRESULT OnReleaseResources();												// Called upon device reset
	HRESULT OnReloadResources();												// Called after device reset
	HRESULT OnDestroyResources();												// Called upon game close
	HRESULT OnMapLoad();														// Called upon map load
	HRESULT OnMapUnload();														// Called upon map unload
	HRESULT OnCustom(unsigned int eventid, float parameter);					// Called whenever a shader custom is sent (via ShaderSend)
	HRESULT OnCustom(unsigned int eventid, Vector4 parameter);					// Called whenever a shader custom is sent (via ShaderSend2)
	HRESULT OnFrameStart();														// Called on frame start
	HRESULT OnFrameEnd();														// Called on frame end
	HRESULT OnScreenFadeRender();												// Called whenever a 'Screen Fade' is to be rendered
	HRESULT OnRender(unsigned int primitive_type, unsigned short start_index,	// Called whenever a draw event occurs.
				unsigned short polygon_count, unsigned short min_vertex_index,		
				unsigned short vertex_count);								
};
